#pragma once
#include <ts/scenario.hpp>
#include "account_media.hpp"

CPPTESK_SCENARIO(AccountScenario)
{
public:
	AccountMediator mediator;
	int limit;

	virtual bool init(int argc, char ** argv);
	virtual void finish();

	bool deposit_scenario(cpptesk::ts::IntCtx& ctx);

	bool withdraw_scenario(cpptesk::ts::IntCtx& ctx);

#ifdef NDFSM
	bool random_withdraw_scenario(cpptesk::ts::IntCtx& ctx);
#endif

	bool get_state_scen();

	int get_state_int();

	AccountScenario(int limit, Account* impl);
	AccountScenario(void) ;
	~AccountScenario(void) ;
};
