#!/bin/bash

if [ -f "$HOME/.vimrc" ]
then
  result="`grep -c cpptesk ~/.vimrc`"
else
  result="0"
fi

case $result in
  "0" )
    cat ../etc/vim/.vimrc >> "$HOME/.vimrc"
    mkdir -p ~/.vim/syntax
    cp -f ../etc/vim/syntax/* ~/.vim/syntax/
    echo "[OK] C++TESK Testing Toolkit's syntax highlighting for vim has been installed."
  ;;
  * )
    echo "[INFO] C++TESK Testing Toolkit's syntax highlighting for vim has been already installed."
  ;;
esac

