/** @file testrepository.cpp
 *  .
 *
 * @author   (chupilko@ispras.ru)
 */

#include <utils/testreg.h>
#include <fifo_scen.h>

using namespace cpptesk::examples::fifo;

///    ExampleScenario
ExampleScenario scen_rnd_example;
ExampleScenario scen_fsm_example;

///  ,       ,    
TEST_REGISTRY_BEGIN
REGISTER_TEST(scen_rnd_example, engine::rnd, "-uerr=1 -nt -p 2000 --length 50000 --parallel")
REGISTER_TEST(scen_fsm_example, engine::fsm, "-uerr=1 -nt -p 2000")
TEST_REGISTRY_END

