/*
 * Copyright 2010 ISP RAS (http://www.ispras.ru), UniTESK Lab (http://www.unitesk.com)
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

#ifndef __NETFSM_AGENT_H
#define __NETFSM_AGENT_H


#include "generator.h"
#include <ts/scenario.h>

#ifdef __cplusplus
#include <ts/scenario.hpp>
extern "C" {
#endif

int netmain(TestEngine *engine, TestScenario *scen, int argc, char **argv);

#ifdef __cplusplus
} // extern "C" 

namespace cpptesk { 
namespace ts {
int netmain(TestEngine *engine, CppTestScenario *scen, int argc, char **argv);
}}

#endif

#endif /* __NETFSM_AGENT_H */

